<?php
/**
 * Index.php
 *
 * @package Divi
 */

use ET\Builder\Framework\Utility\PostUtility;

get_header(); ?>

<div id="main-content">
	<div class="container">
		<div id="content-area" class="clearfix">
			<div id="left-area">
		<?php
		if ( have_posts() ) :
			while ( have_posts() ) :
				the_post();
				$post_format = et_pb_post_format();
				?>

					<article id="post-<?php the_ID(); ?>" <?php post_class( 'et_pb_post' ); ?>>

				<?php
				$thumb = '';

				$width = (int) apply_filters( 'et_pb_index_blog_image_width', 1080 );

				$height    = (int) apply_filters( 'et_pb_index_blog_image_height', 675 );
				$classtext = 'et_pb_post_main_image';
				$titletext = get_the_title();
				$alttext   = get_post_meta( get_post_thumbnail_id(), '_wp_attachment_image_alt', true );
				$thumbnail = get_thumbnail( $width, $height, $classtext, $alttext, $titletext, false, 'Blogimage' );
				$thumb     = $thumbnail['thumb'];

				et_divi_post_format_content();

				if ( ! in_array( $post_format, array( 'link', 'audio', 'quote' ), true ) ) {
					$first_video = PostUtility::get_first_video();

					if ( 'video' === $post_format && false !== $first_video ) :
						printf(
							'<div class="et_main_video_container">
									%1$s
								</div>',
							et_core_esc_previously( $first_video )
						);
					elseif ( ! in_array( $post_format, array( 'gallery' ), true ) && 'on' === et_get_option( 'divi_thumbnails_index', 'on' ) && '' !== $thumb ) :
						?>
							<a class="entry-featured-image-url" href="<?php the_permalink(); ?>">
								<?php print_thumbnail( $thumb, $thumbnail['use_timthumb'], $titletext, $width, $height ); ?>
							</a>
						<?php
						elseif ( 'gallery' === $post_format ) :
							et_pb_gallery_images();
						endif;
				}
				?>

				<?php if ( ! in_array( $post_format, array( 'link', 'audio', 'quote' ), true ) ) : ?>
					<?php if ( ! in_array( $post_format, array( 'link', 'audio' ), true ) ) : ?>
						<h2 class="entry-title"><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>
					<?php endif; ?>

					<?php
						et_divi_post_meta();

					if ( 'on' !== et_get_option( 'divi_blog_style', 'false' ) || ( is_search() && ( 'on' === get_post_meta( get_the_ID(), '_et_pb_use_builder', true ) ) ) ) {
						truncate_post( 270 );
					} else {
						the_content();
					}
					?>
				<?php endif; ?>

					</article>
				<?php
				endwhile;

			if ( function_exists( 'wp_pagenavi' ) ) {
				wp_pagenavi();
			} else {
				get_template_part( 'includes/navigation', 'index' );
			} else :
				get_template_part( 'includes/no-results', 'index' );
				endif;
			?>
			</div>

			<?php get_sidebar(); ?>
		</div>
	</div>
</div>

<?php

get_footer();
